(******************************************************************************

______________________________________________________________________________

ColBuild v0.10                                               (c) 2009-12 Pepak
http://www.pepak.net/e-books/prs-505-sbirky/              http://www.pepak.net
______________________________________________________________________________


Copyright (c) 2009-12 Pepak (http://www.pepak.net)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of Pepak nor the
      names of his contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL PEPAK BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

******************************************************************************)

unit uMedia;

interface

uses
  SysUtils, Classes, Windows;

type
  TMediaType = (mtInternalMemory, mtSDcard, mtMScard);
  TMediaTypes = set of TMediaType;
  TMediaTypeInfo = record
    ShortID: string;
    LongID: string;
    Description: string;
  end;

const
  MediaTypeInfo: array[TMediaType] of TMediaTypeInfo = (
    (ShortID: 'int'; LongID: 'internal-memory'; Description: 'Internal memory'),
    (ShortID: 'sd';  LongID: 'sd-card';         Description: 'SD card'),
    (ShortID: 'ms';  LongID: 'ms-card';         Description: 'MS card')
  );

function StrToMediaType(const ID: string; out MediaType: TMediaType): boolean;
function StrToMediaTypeDef(const ID: string; const Default: TMediaType): TMediaType;

implementation

function StrToMediaType(const ID: string; out MediaType: TMediaType): boolean;
var
  mt: TMediaType;
begin
  Result := False;
  for mt := Low(TMediaType) to High(TMediaType) do
    if AnsiCompareText(ID, MediaTypeInfo[mt].ShortID) = 0 then
      begin
      MediaType := mt;
      Result := True;
      Break;
      end;
  if not Result then
    for mt := Low(TMediaType) to High(TMediaType) do
      if AnsiCompareText(ID, MediaTypeInfo[mt].LongID) = 0 then
        begin
        MediaType := mt;
        Result := True;
        Break;
        end;
end;

function StrToMediaTypeDef(const ID: string; const Default: TMediaType): TMediaType;
begin
  if not StrToMediaType(ID, Result) then
    Result := Default;
end;

end.
